#version 330 core

precision highp float;

in vec2 uv_00; in vec2 uv_01; in vec2 uv_02; in vec2 uv_03; in vec2 uv_04;
in vec2 uv_10; in vec2 uv_11; in vec2 uv_12; in vec2 uv_13; in vec2 uv_14;
in vec2 uv_20; in vec2 uv_21; in vec2 uv_22; in vec2 uv_23; in vec2 uv_24;
in vec2 uv_30; in vec2 uv_31; in vec2 uv_32; in vec2 uv_33; in vec2 uv_34;
in vec2 uv_40; in vec2 uv_41; in vec2 uv_42; in vec2 uv_43; in vec2 uv_44;

// texture sampler
uniform sampler2D color;
uniform sampler2D outlines;

// output fragment colour RGBA
layout(location = 0, index = 0) out vec4 outputColor;
layout(location = 0, index = 1) out vec4 outputOutlines;

void main () {
	float c_00   = texture2D(outlines, uv_00).r;
	float c_01   = texture2D(outlines, uv_01).r;
	float c_02   = texture2D(outlines, uv_02).r;
	float c_03   = texture2D(outlines, uv_03).r;
	float c_04   = texture2D(outlines, uv_04).r;

	float c_10   = texture2D(outlines, uv_10).r;
	float c_11   = texture2D(outlines, uv_11).r;
	float c_12   = texture2D(outlines, uv_12).r;
	float c_13   = texture2D(outlines, uv_13).r;
	float c_14   = texture2D(outlines, uv_14).r;

	float c_20   = texture2D(outlines, uv_20).r;
	float c_21   = texture2D(outlines, uv_21).r;
	float c_22   = texture2D(outlines, uv_22).r;
	float c_23   = texture2D(outlines, uv_23).r;
	float c_24   = texture2D(outlines, uv_24).r;

	float c_30   = texture2D(outlines, uv_30).r;
	float c_31   = texture2D(outlines, uv_31).r;
	float c_32   = texture2D(outlines, uv_32).r;
	float c_33   = texture2D(outlines, uv_33).r;
	float c_34   = texture2D(outlines, uv_34).r;

	float c_40   = texture2D(outlines, uv_40).r;
	float c_41   = texture2D(outlines, uv_41).r;
	float c_42   = texture2D(outlines, uv_42).r;
	float c_43   = texture2D(outlines, uv_43).r;
	float c_44   = texture2D(outlines, uv_44).r;

	float intensity = 1.f/273.f * (
		1.f * c_00 +  4.f * c_01 +  7.f * c_02 +  4.f * c_03 + 1.f * c_04 +
		4.f * c_10 + 16.f * c_11 + 26.f * c_12 + 16.f * c_13 + 4.f * c_14 +
		7.f * c_20 + 26.f * c_21 + 41.f * c_22 + 26.f * c_23 + 7.f * c_24 +
		4.f * c_30 + 16.f * c_31 + 26.f * c_32 + 16.f * c_33 + 4.f * c_34 +
		1.f * c_40 +  4.f * c_41 +  7.f * c_42 +  4.f * c_43 + 1.f * c_44
	);

	outputColor = vec4(texture(color, uv_22).a * texture(color, uv_22).rgb -
	           intensity * vec3(1.f), 1.f);
	//if (intensity > 0.3f) {
	//	outputOutlines = vec4(vec3(1.f), 1.f);
	//} else {
	//	outputOutlines = vec4(vec3(1.f), 1.f);
	//}
	//outputColor = vec4(vec3(intensity),1.f);
	//outputColor = texture(color, uv_33);
}
