#version 330 core

layout(location = 0) in vec2 position;
layout(location = 1) in vec2 uv;

uniform highp float imageWidthFactor;
uniform highp float imageHeightFactor;

out vec2 uv_00; out vec2 uv_01; out vec2 uv_02; out vec2 uv_03; out vec2 uv_04;
out vec2 uv_10; out vec2 uv_11; out vec2 uv_12; out vec2 uv_13; out vec2 uv_14;
out vec2 uv_20; out vec2 uv_21; out vec2 uv_22; out vec2 uv_23; out vec2 uv_24;
out vec2 uv_30; out vec2 uv_31; out vec2 uv_32; out vec2 uv_33; out vec2 uv_34;
out vec2 uv_40; out vec2 uv_41; out vec2 uv_42; out vec2 uv_43; out vec2 uv_44;

void main () {
	gl_Position = vec4(position, 0.f, 1.f);

	vec2 widthStep = vec2(imageWidthFactor, 0.0);
	vec2 heightStep = vec2(0.0, imageHeightFactor);
	vec2 widthHeightStep = vec2(imageWidthFactor, imageHeightFactor);

	uv_00 = uv.xy - widthStep * 2.f - heightStep * 2.f;
	uv_01 = uv.xy - widthStep * 1.f - heightStep * 2.f;
	uv_02 = uv.xy - widthStep * 0.f - heightStep * 2.f;
	uv_03 = uv.xy + widthStep * 1.f - heightStep * 2.f;
	uv_04 = uv.xy + widthStep * 2.f - heightStep * 2.f;

	uv_10 = uv.xy - widthStep * 2.f - heightStep * 1.f;
	uv_11 = uv.xy - widthStep * 1.f - heightStep * 1.f;
	uv_12 = uv.xy - widthStep * 0.f - heightStep * 1.f;
	uv_13 = uv.xy + widthStep * 1.f - heightStep * 1.f;
	uv_14 = uv.xy + widthStep * 2.f - heightStep * 1.f;

	uv_20 = uv.xy - widthStep * 2.f - heightStep * 0.f;
	uv_21 = uv.xy - widthStep * 1.f - heightStep * 0.f;
	uv_22 = uv.xy - widthStep * 0.f - heightStep * 0.f;
	uv_23 = uv.xy + widthStep * 1.f - heightStep * 0.f;
	uv_24 = uv.xy + widthStep * 2.f - heightStep * 0.f;

	uv_30 = uv.xy - widthStep * 2.f + heightStep * 1.f;
	uv_31 = uv.xy - widthStep * 1.f + heightStep * 1.f;
	uv_32 = uv.xy - widthStep * 0.f + heightStep * 1.f;
	uv_33 = uv.xy + widthStep * 1.f + heightStep * 1.f;
	uv_34 = uv.xy + widthStep * 2.f + heightStep * 1.f;

	uv_40 = uv.xy - widthStep * 2.f + heightStep * 2.f;
	uv_41 = uv.xy - widthStep * 1.f + heightStep * 2.f;
	uv_42 = uv.xy - widthStep * 0.f + heightStep * 2.f;
	uv_43 = uv.xy + widthStep * 1.f + heightStep * 2.f;
	uv_44 = uv.xy + widthStep * 2.f + heightStep * 2.f;
}
