#version 330 core

precision highp float;

in vec2 textureCoordinate;
in vec2 leftTextureCoordinate;
in vec2 rightTextureCoordinate;

in vec2 topTextureCoordinate;
in vec2 topLeftTextureCoordinate;
in vec2 topRightTextureCoordinate;

in vec2 bottomTextureCoordinate;
in vec2 bottomLeftTextureCoordinate;
in vec2 bottomRightTextureCoordinate;

// texture sampler
uniform sampler2D normals;

// output fragment colour RGBA
layout(location = 0) out vec4 outputOutlines;

void main () {
	float i00   = texture2D(normals, textureCoordinate).r;
	float im1m1 = texture2D(normals, bottomLeftTextureCoordinate).r;
	float ip1p1 = texture2D(normals, topRightTextureCoordinate).r;
	float im1p1 = texture2D(normals, topLeftTextureCoordinate).r;
	float ip1m1 = texture2D(normals, bottomRightTextureCoordinate).r;
	float im10 = texture2D(normals, leftTextureCoordinate).r;
	float ip10 = texture2D(normals, rightTextureCoordinate).r;
	float i0m1 = texture2D(normals, bottomTextureCoordinate).r;
	float i0p1 = texture2D(normals, topTextureCoordinate).r;
	float h1 = -im1p1 - 2.0 * i0p1 - ip1p1 + im1m1 + 2.0 * i0m1 + ip1m1;
	float v1 = -im1m1 - 2.0 * im10 - im1p1 + ip1m1 + 2.0 * ip10 + ip1p1;

	float mag = length(vec2(h1, v1));

	if (mag > 0.5f) {
		outputOutlines = vec4(vec3(mag), 1.f);
	} else {
		outputOutlines = vec4(vec3(0.f), 1.f);
	}
	//outputColor = texture(normals, textureCoordinate);
}
