#version 330 core

layout(location = 0) in vec2 position;
layout(location = 1) in vec2 uv;

uniform highp float imageWidthFactor;
uniform highp float imageHeightFactor;

out vec2 textureCoordinate;
out vec2 leftTextureCoordinate;
out vec2 rightTextureCoordinate;

out vec2 topTextureCoordinate;
out vec2 topLeftTextureCoordinate;
out vec2 topRightTextureCoordinate;

out vec2 bottomTextureCoordinate;
out vec2 bottomLeftTextureCoordinate;
out vec2 bottomRightTextureCoordinate;

void main () {
	gl_Position = vec4(position, 0.f, 1.f);

	vec2 widthStep = vec2(imageWidthFactor, 0.0);
	vec2 heightStep = vec2(0.0, imageHeightFactor);
	vec2 widthHeightStep = vec2(imageWidthFactor, imageHeightFactor);
	vec2 widthNegativeHeightStep = vec2(imageWidthFactor, -imageHeightFactor);

	textureCoordinate = uv;
	leftTextureCoordinate = uv.xy - widthStep;
	rightTextureCoordinate = uv.xy + widthStep;

	topTextureCoordinate = uv.xy + heightStep;
	topLeftTextureCoordinate = uv.xy - widthNegativeHeightStep;
	topRightTextureCoordinate = uv.xy + widthHeightStep;

	bottomTextureCoordinate = uv.xy - heightStep;
	bottomLeftTextureCoordinate = uv.xy - widthHeightStep;
	bottomRightTextureCoordinate = uv.xy + widthNegativeHeightStep;
}
