#version 330
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;

in vec4 position;

smooth out vec3 eyeDirection;

void main() {
    mat4 inverseProjection = inverse(viewMatrix);
    mat3 inverseModelview = transpose(mat3(projectionMatrix));
    vec3 unprojected = (inverseProjection * position).xyz;
    eyeDirection = inverseModelview * unprojected;

    gl_Position = position;
}
